CGOMesh
Date: 2019-10-22

org.jmol.shapecgo

## Class CGOMesh

- java.lang.Object
- - org.jmol.util.MeshSurface
  - - org.jmol.shape.Mesh
    - - org.jmol.shapespecial.DrawMesh
      - - org.jmol.shapecgo.CGOMesh

-     public class CGOMesh
      extends DrawMesh

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ALPHA`
    `static int` | `ALPHA_TRIANGLE`
    `static int` | `BEGIN`
    `static int` | `CHAR`
    `javajs.util.Lst<java.lang.Short>` | `cList`
    `javajs.util.Lst<java.lang.Object>` | `cmds`
    `static int` | `COLOR`
    `static int` | `CONE`
    `static int` | `CUSTOM_CYLINDER`
    `static int` | `CYLINDER`
    `static int` | `DISABLE`
    `static int` | `DOTWIDTH`
    `static int` | `ELLIPSOID`
    `static int` | `ENABLE`
    `static int` | `END`
    `static int` | `FONT`
    `static int` | `FONT_AXES`
    `static int` | `FONT_SCALE`
    `static int` | `FONT_VERTEX`
    `static int` | `GL_LINE_LOOP`
    `static int` | `GL_LINE_STRIP`
    `static int` | `GL_LINES`
    `static int` | `GL_POINTS`
    `static int` | `GL_TRIANGLE_FAN`
    `static int` | `GL_TRIANGLE_STRIP`
    `static int` | `GL_TRIANGLES`
    `static int` | `INDENT`
    `static int` | `JMOL_DIAMETER`
    `static int` | `JMOL_PS`
    `static int` | `JMOL_SCREEN`
    `static int` | `JMOL_UVMAP`
    `private static java.lang.String` | `KEY_LIST`
    `private static java.util.Map<java.lang.String,java.lang.Integer>` | `keyMap`
    `static int` | `LINEWIDTH`
    `javajs.util.Lst<java.lang.Short>` | `nList`
    `static int` | `NORMAL`
    `static int` | `PICK_COLOR`
    `static int` | `PS_CLOSEPATH`
    `static int` | `PS_LINETO`
    `static int` | `PS_MOVETO`
    `static int` | `PS_NEWPATH`
    `static int` | `PS_SCALE`
    `static int` | `PS_SETLINEWIDTH`
    `static int` | `PS_SHOWPAGE`
    `static int` | `PS_STROKE`
    `static int` | `QUADRIC`
    `static int` | `RESET_NORMAL`
    `static int` | `SAUSAGE`
    `static int` | `SIMPLE_LINE`
    `private static int[]` | `sizes`
    `private static int[]` | `sizes2D`
    `static int` | `SPHERE`
    `static int` | `STOP`
    `static int` | `TRICOLOR_TRIANGLE`
    `static int` | `VERTEX`
    `static int` | `WIDTHSCALE`

    - ### Fields inherited from class org.jmol.shapespecial.DrawMesh

      `bsMeshesVisible, drawArrowScale, drawType, isBarb, isScaleSet, isVector, modelFlags, noHead, scale`

    - ### Fields inherited from class org.jmol.shape.Mesh

      `atomIndex, bsTemp, cappingObject, checkByteCount, color, colorCommand, colorDensity, colorType, connectedAtoms, diameter, drawTriangles, fillTriangles, frontOnly, havePlanarContours, haveXyPoints, index, insideOut, isModelConnected, isShell, isTwoSided, isValid, lattice, lighting, lineData, linkedMesh, meshColix, modelIndex, normixes, PREVIOUS_MESH_ID, ptCenter, recalcAltVertices, scale3d, scriptCommand, showContourLines, showPoints, showTriangles, slabbingObject, symopColixes, symopNormixes, symops, thisID, title, unitCell, useColix, vAB, vertexColorMap, visibilityFlags, visible, volumeRenderPointSize, vTemp, width`

    - ### Fields inherited from class org.jmol.util.MeshSurface

      `altVertices, bsDisplay, bsPolygons, bsSlabDisplay, bsSlabGhost, colix, colixBack, colorsExplicit, dataOnly, haveQuads, iA, iB, iC, isColorSolid, isDrawPolygon, isMerged, mat4, mergePolygonCount0, mergeVertexCount0, meshType, normalCount, normals, normalsTemp, normixCount, nSets, oabc, offset, P_CHECK, P_CONTOUR, P_EXPLICIT_COLOR, pc, pcs, pis, polygonCount0, SEED_COUNT, slabColix, slabMeshType, slabOptions, surfaceAtoms, surfaceSet, vc, vcs, vertexCount0, vertexSets, vertexSource, vs, vvs, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CGOMesh(Viewer vwr, java.lang.String thisID, short colix, int index)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `addColix(int i)`
    `private static int` | `addItems(int i, T[] st, int slen, javajs.util.Lst<java.lang.Object> data, Viewer vwr)`
    `private static boolean` | `addKey(javajs.util.Lst<java.lang.Object> data, java.lang.String key)`
    `private void` | `addNormix(int i)`
    `void` | `clear(java.lang.String meshType)`
    `(package private) static boolean` | `getData(java.lang.Object[] d)`
    `float` | `getFloat(int i)`
    `int` | `getInt(int i)`
    `static java.util.Map<java.lang.String,java.lang.Integer>` | `getKeyMap()`
    `void` | `getPoint(int i, javajs.util.T3 pt)`
    `static int` | `getSize(int i, boolean is2D)`
    `private static boolean` | `parseEPSData(java.lang.String eps, javajs.util.Lst<java.lang.Object> data)`
    `(package private) boolean` | `set(javajs.util.Lst<java.lang.Object> list)`

    - ### Methods inherited from class org.jmol.shapespecial.DrawMesh

      `deleteAtoms, isRenderScalable`

    - ### Methods inherited from class org.jmol.shape.Mesh

      `checkWithin, clearMesh, getBoundingBox, getMinDistance2ForVertexGrouping, getNormals, getNormalsTemp, getOffsetVertices, getRendering, getState, getUnitCell, getVertexIndexFromNumber, getVisibleVBS, getVisibleVertexBitSet, initialize, mesh1, rotateTranslate, setLighting, setNormixes, setShowWithin, setTokenProperty, setTranslucent, setVisibilityFlags, sumVertexNormals, sumVertexNormals2`

    - ### Methods inherited from class org.jmol.util.MeshSurface

      `addPolygon, addPolygonC, addQuad, addTriangle, addTriangleCheck, addV, addVCVal, getFaces, getMeshSlicer, getResolution, getSlabColor, getSlabType, getSphereData, getSphericalInterpolationFraction, getVertices, invalidatePolygons, newMesh, resetSlab, setABC, setBoundingBox, setBox, setColix, setColixBack, setPolygonCount, setTranslucentVertices, slabBrillouin, slabPolygonsList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### cmds

          public javajs.util.Lst<java.lang.Object> cmds

    - #### GL_POINTS

          public static final int GL_POINTS

      See Also:
        Constant Field Values

    - #### GL_LINES

          public static final int GL_LINES

      See Also:
        Constant Field Values

    - #### GL_LINE_LOOP

          public static final int GL_LINE_LOOP

      See Also:
        Constant Field Values

    - #### GL_LINE_STRIP

          public static final int GL_LINE_STRIP

      See Also:
        Constant Field Values

    - #### GL_TRIANGLES

          public static final int GL_TRIANGLES

      See Also:
        Constant Field Values

    - #### GL_TRIANGLE_STRIP

          public static final int GL_TRIANGLE_STRIP

      See Also:
        Constant Field Values

    - #### GL_TRIANGLE_FAN

          public static final int GL_TRIANGLE_FAN

      See Also:
        Constant Field Values

    - #### STOP

          public static final int STOP

      See Also:
        Constant Field Values

    - #### SIMPLE_LINE

          public static final int SIMPLE_LINE

      See Also:
        Constant Field Values

    - #### BEGIN

          public static final int BEGIN

      See Also:
        Constant Field Values

    - #### END

          public static final int END

      See Also:
        Constant Field Values

    - #### VERTEX

          public static final int VERTEX

      See Also:
        Constant Field Values

    - #### NORMAL

          public static final int NORMAL

      See Also:
        Constant Field Values

    - #### COLOR

          public static final int COLOR

      See Also:
        Constant Field Values

    - #### SPHERE

          public static final int SPHERE

      See Also:
        Constant Field Values

    - #### TRICOLOR_TRIANGLE

          public static final int TRICOLOR_TRIANGLE

      See Also:
        Constant Field Values

    - #### CYLINDER

          public static final int CYLINDER

      See Also:
        Constant Field Values

    - #### LINEWIDTH

          public static final int LINEWIDTH

      See Also:
        Constant Field Values

    - #### WIDTHSCALE

          public static final int WIDTHSCALE

      See Also:
        Constant Field Values

    - #### ENABLE

          public static final int ENABLE

      See Also:
        Constant Field Values

    - #### DISABLE

          public static final int DISABLE

      See Also:
        Constant Field Values

    - #### SAUSAGE

          public static final int SAUSAGE

      See Also:
        Constant Field Values

    - #### CUSTOM_CYLINDER

          public static final int CUSTOM_CYLINDER

      See Also:
        Constant Field Values

    - #### DOTWIDTH

          public static final int DOTWIDTH

      See Also:
        Constant Field Values

    - #### ALPHA_TRIANGLE

          public static final int ALPHA_TRIANGLE

      See Also:
        Constant Field Values

    - #### ELLIPSOID

          public static final int ELLIPSOID

      See Also:
        Constant Field Values

    - #### FONT

          public static final int FONT

      See Also:
        Constant Field Values

    - #### FONT_SCALE

          public static final int FONT_SCALE

      See Also:
        Constant Field Values

    - #### FONT_VERTEX

          public static final int FONT_VERTEX

      See Also:
        Constant Field Values

    - #### FONT_AXES

          public static final int FONT_AXES

      See Also:
        Constant Field Values

    - #### CHAR

          public static final int CHAR

      See Also:
        Constant Field Values

    - #### INDENT

          public static final int INDENT

      See Also:
        Constant Field Values

    - #### ALPHA

          public static final int ALPHA

      See Also:
        Constant Field Values

    - #### QUADRIC

          public static final int QUADRIC

      See Also:
        Constant Field Values

    - #### CONE

          public static final int CONE

      See Also:
        Constant Field Values

    - #### RESET_NORMAL

          public static final int RESET_NORMAL

      See Also:
        Constant Field Values

    - #### PICK_COLOR

          public static final int PICK_COLOR

      See Also:
        Constant Field Values

    - #### sizes

          private static final int[] sizes

    - #### sizes2D

          private static final int[] sizes2D

    - #### JMOL_DIAMETER

          public static final int JMOL_DIAMETER

      See Also:
        Constant Field Values

    - #### JMOL_SCREEN

          public static final int JMOL_SCREEN

      See Also:
        Constant Field Values

    - #### JMOL_UVMAP

          public static final int JMOL_UVMAP

      See Also:
        Constant Field Values

    - #### JMOL_PS

          public static final int JMOL_PS

      See Also:
        Constant Field Values

    - #### PS_NEWPATH

          public static final int PS_NEWPATH

      See Also:
        Constant Field Values

    - #### PS_CLOSEPATH

          public static final int PS_CLOSEPATH

      See Also:
        Constant Field Values

    - #### PS_STROKE

          public static final int PS_STROKE

      See Also:
        Constant Field Values

    - #### PS_SETLINEWIDTH

          public static final int PS_SETLINEWIDTH

      See Also:
        Constant Field Values

    - #### PS_SCALE

          public static final int PS_SCALE

      See Also:
        Constant Field Values

    - #### PS_MOVETO

          public static final int PS_MOVETO

      See Also:
        Constant Field Values

    - #### PS_LINETO

          public static final int PS_LINETO

      See Also:
        Constant Field Values

    - #### PS_SHOWPAGE

          public static final int PS_SHOWPAGE

      See Also:
        Constant Field Values

    - #### KEY_LIST

          private static final java.lang.String KEY_LIST

      See Also:
        Constant Field Values

    - #### keyMap

          private static java.util.Map<java.lang.String,java.lang.Integer> keyMap

    - #### nList

          public javajs.util.Lst<java.lang.Short> nList

    - #### cList

          public javajs.util.Lst<java.lang.Short> cList

  - ### Constructor Detail

    - #### CGOMesh

          CGOMesh(Viewer vwr,
                  java.lang.String thisID,
                  short colix,
                  int index)

  - ### Method Detail

    - #### getSize

          public static int getSize(int i,
                                    boolean is2D)

    - #### getKeyMap

          public static java.util.Map<java.lang.String,java.lang.Integer> getKeyMap()

    - #### getData

          static boolean getData(java.lang.Object[] d)

    - #### parseEPSData

          private static boolean parseEPSData(java.lang.String eps,
                                              javajs.util.Lst<java.lang.Object> data)

    - #### addItems

          private static int addItems(int i,
                                      T[] st,
                                      int slen,
                                      javajs.util.Lst<java.lang.Object> data,
                                      Viewer vwr)

    - #### addKey

          private static boolean addKey(javajs.util.Lst<java.lang.Object> data,
                                        java.lang.String key)

    - #### clear

          public void clear(java.lang.String meshType)

      Overrides:
        `clear` in class `DrawMesh`

    - #### set

          boolean set(javajs.util.Lst<java.lang.Object> list)

    - #### addColix

          private void addColix(int i)

    - #### addNormix

          private void addNormix(int i)

    - #### getPoint

          public void getPoint(int i,
                               javajs.util.T3 pt)

      Parameters:
        `i` - pointer to PRECEDING item
        `pt` -

    - #### getInt

          public int getInt(int i)

      Parameters:
        `i` - pointer to THIS value
      Returns:
        int

    - #### getFloat

          public float getFloat(int i)

      Parameters:
        `i` - pointer to THIS value
      Returns:
        float